#include <stdlib.h>
#include <stdio.h>
#include <pthread.h>
#include <caml/mlvalues.h>
#include <caml/startup.h>
#include <caml/callback.h>
#include <caml/threads.h>

static void *another_thread(void *wtv)
{
  (void)wtv;
  caml_c_thread_register();
  printf("in another_thread\n");
  caml_acquire_runtime_system();
  value *cb = caml_named_value("call_me_from_c");
  caml_callback(*cb, Val_unit);
  caml_release_runtime_system();
  caml_c_thread_unregister();
  return NULL;
}

int main(int argc, char *argv[])
{
  (void)argc;
  caml_startup(argv);
  caml_release_runtime_system();

  pthread_t th;
  (void)pthread_create(&th, NULL, another_thread, NULL);

  (void)pthread_join(th, NULL);

  return 0;
}
